"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyDirectiveTransformers = exports.directiveTypeDefs = void 0;
const apollo_server_core_1 = require("apollo-server-core");
const auth_directive_1 = require("./graphql-directives/auth.directive");
const has_ability_directive_1 = require("./graphql-directives/has-ability.directive");
exports.directiveTypeDefs = (0, apollo_server_core_1.gql) `
    ${auth_directive_1.authDirectiveTypeDefs}
    ${has_ability_directive_1.hasAbilityDirectiveTypeDefs}
`;
function applyDirectiveTransformers(schema) {
    return (0, auth_directive_1.authDirective)((0, has_ability_directive_1.hasAbilityDirective)(schema));
}
exports.applyDirectiveTransformers = applyDirectiveTransformers;
//# sourceMappingURL=app-graphql-directive.js.map