"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthBasic = void 0;
const cm_libs_context_aware_error_1 = require("cm-libs-context-aware-error");
const auth_type_1 = require("./auth-type");
class AuthBasic {
    constructor(fnVerify) {
        this.fnVerify = fnVerify;
    }
    static init(fnVerify) {
        this.self = new AuthBasic(fnVerify);
    }
    static async updateAuthToken(authToken, username, password, channel) {
        const idToken = await this.instance.fnVerify({ username, password, channel });
        authToken.type = auth_type_1.AuthTokenType.Basic;
        authToken.grant = true;
        authToken.info.auth = idToken;
        authToken.info.requestedBy = idToken.userId;
        return authToken;
    }
    static get instance() {
        return this.self || (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.NOT_INITIALIZED, 'AuthBasic initialization is required');
    }
}
exports.AuthBasic = AuthBasic;
//# sourceMappingURL=auth-basic.js.map