/// <reference types="node" />
export declare const DEFAULT_CIPHER_ALGO = "aes-256-cbc";
export declare const DEFAULT_IV_LENGTH = 16;
export declare type BdkSet = {
    [keySetId: string]: Buffer;
};
export declare class DomainEventCipher {
    private static self;
    readonly cipherAlgo: string;
    readonly cipherKeyLength: number;
    readonly cipherIvLength: number;
    private bdkSet;
    private ksn;
    private schemaPayload;
    private _bdk;
    private _encKey;
    private bdkThreshold;
    private trsmThreshold;
    private constructor();
    static init(bdkSet: BdkSet, ksn: Buffer, cipherAlgo?: string, ivLength?: number): void;
    private static get instance();
    static encrypt(buffer: Buffer): Promise<Buffer>;
    static decrypt(buffer: Buffer): Promise<Buffer>;
    private get encKey();
    private getBdk;
    private getCipherKeyLength;
}
