'use strict';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DomainEventCodec = void 0;
const cm_schema_event_1 = require("cm-schema-event");
const domain_schema_1 = require("./domain-schema");
const domain_event_cipher_1 = require("./domain-event-cipher");
__exportStar(require("./domain-event-cipher"), exports);
class DomainEventCodec {
    constructor() {
        // Load schema from the central schema registry
        this.schemaMessage = new domain_schema_1.DomainSchema(cm_schema_event_1.Schema.DomainEventMessage);
    }
    async encode(message) {
        const encodedMessage = await this.schemaMessage.encode(message);
        return domain_event_cipher_1.DomainEventCipher.encrypt(encodedMessage);
    }
    async decode(encodedBuffer) {
        const encodedMessage = await domain_event_cipher_1.DomainEventCipher.decrypt(encodedBuffer);
        return this.schemaMessage.decode(encodedMessage);
    }
}
exports.DomainEventCodec = DomainEventCodec;
//# sourceMappingURL=domain-event-codec.js.map