import { KafkaProducer } from 'cm-libs-kafka';
import { DomainEventMessage } from './domain-event';
export * from 'cm-libs-kafka';
export declare class DomainEventProducer<T, M> {
    private readonly kafkaConfig;
    readonly topics: string[];
    private producer;
    private domainEvent;
    constructor(kafkaConfig: string, topics: string[], schema: string | Record<string, any>, metadataSchema?: string | Record<string, any>);
    term(): Promise<void>;
    publish(message: DomainEventMessage<T, M>, topic?: string): Promise<import("kafkajs").RecordMetadata[]>;
    getProducer(): Promise<KafkaProducer>;
    get ready(): boolean;
    get schemaRegistryId(): number;
    get metadataSchemaRegistryId(): number;
}
