/// <reference types="node" />
import Avro from 'avsc';
import { SchemaRegistry } from '@kafkajs/confluent-schema-registry';
export { Avro };
export * from '@kafkajs/confluent-schema-registry';
export declare class DomainSchema<T> {
    readonly schemaValue: string;
    private readonly schema;
    private _registryId;
    constructor(schema?: string | Record<string, any>, disableSchemaRegistry?: boolean);
    encode(value: T): Promise<Buffer>;
    decode(value: Buffer): Promise<T>;
    get registryId(): number;
}
export declare class Registry {
    private static self;
    private registry;
    private constructor();
    static init(url: string, overrides?: any): void;
    static get instance(): SchemaRegistry;
}
