import Joi from 'joi';
import { Algorithm, JwtBaseToken, BaseToken, BaseTokenClaim } from './base-token';
export * from './base-token';
export declare type IdToken = BaseToken & {
    userId: string;
    localeCode: string;
    rules: string;
};
export declare const schemaIdToken: {
    userId: Joi.StringSchema;
    ruleId: Joi.StringSchema;
    localeCode: Joi.StringSchema;
    kind: Joi.StringSchema;
    channel: Joi.StringSchema;
};
export declare type IdTokenClaim = BaseTokenClaim & {
    userId: string;
    localeCode: string;
};
export declare const schemaIdTokenClaim: {
    userId: Joi.StringSchema;
    localeCode: Joi.StringSchema;
    iat: Joi.NumberSchema;
    exp: Joi.NumberSchema;
    kind: Joi.StringSchema;
    channel: Joi.StringSchema;
};
export declare class JwtIdToken extends JwtBaseToken<IdTokenClaim> {
    private static self;
    private constructor();
    static init(secret: string, expiresIn: string | number, algorithm?: Algorithm): typeof JwtIdToken;
    static term(): void;
    static sign(claim: IdTokenClaim, expiresIn?: string | number, notBefore?: string | number): string;
    static verify(token: string): IdTokenClaim;
    private static get instance();
    static get isEnabled(): boolean;
}
