"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JwtIdToken = exports.schemaIdTokenClaim = exports.schemaIdToken = void 0;
const joi_1 = __importDefault(require("joi"));
const cm_libs_context_aware_error_1 = require("cm-libs-context-aware-error");
const base_token_1 = require("./base-token");
__exportStar(require("./base-token"), exports);
exports.schemaIdToken = {
    ...base_token_1.schemaBaseToken,
    userId: joi_1.default.string().required(),
    ruleId: joi_1.default.string().required(),
    localeCode: joi_1.default.string().required()
};
exports.schemaIdTokenClaim = {
    ...base_token_1.schemaBaseTokenClaim,
    userId: joi_1.default.string().required(),
    localeCode: joi_1.default.string().required()
};
class JwtIdToken extends base_token_1.JwtBaseToken {
    constructor(secret, expiresIn, schema, algorithm) {
        super(secret, expiresIn, schema, algorithm);
    }
    static init(secret, expiresIn, algorithm) {
        this.self = new JwtIdToken(secret, expiresIn, joi_1.default.object(exports.schemaIdTokenClaim), algorithm);
        return this;
    }
    static term() {
        this.self = undefined;
    }
    static sign(claim, expiresIn, notBefore) {
        if (base_token_1.TokenKind.TOKEN !== claim.kind) {
            (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.INVALID_MESSAGE, 'Token kind is invalid', { claim });
        }
        return JwtIdToken.instance.sign(claim, expiresIn, notBefore);
    }
    static verify(token) {
        const claim = JwtIdToken.instance.verify(token);
        /* istanbul ignore next */
        if (base_token_1.TokenKind.TOKEN !== claim.kind) {
            (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.INVALID_MESSAGE, 'Token kind is invalid', { claim });
        }
        return claim;
    }
    static get instance() {
        return this.self || (0, cm_libs_context_aware_error_1.throwError)(cm_libs_context_aware_error_1.errors.NOT_INITIALIZED, 'JwtIdToken initialization is required');
    }
    static get isEnabled() {
        return undefined !== this.self;
    }
}
exports.JwtIdToken = JwtIdToken;
//# sourceMappingURL=id-token.js.map