/// <reference types="node" />
import { ContextAwareError } from 'cm-libs-context-aware-error';
import { TcpBase, Socket, TcpConnection } from './tcp-base';
export * from './tcp-base';
export declare abstract class TcpClient<T> extends TcpBase<T> {
    protected abstract onConnect(clientId: string, hostname: string, port: number, timeout?: number): Promise<void>;
    protected connect(clientId: string, hostname: string, port: number, connectTimeout: number, ref?: T, keepAliveInterval?: number, idleTimeout?: number, detectEarlyClosure?: number): Promise<TcpConnection<T>>;
    protected raiseConnectionError(socket: Socket, clientId: string, error: ContextAwareError | Error): Promise<void>;
}
